/***************************************************************************
Name: CS Lite
Description: Control cookie permissions.
Author: Ron Beckman
Homepage: http://forum.softwareblaze.com

Copyright (C) 2007  Ron Beckman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

Free Software Foundation, Inc.
51 Franklin Street
Fifth Floor
Boston, MA  02110-1301
USA
***************************************************************************/



var csGlobalPrompt = {

	onDialogLoad: function() {
		var dom = this.getDOM();
		var prefs = this.getPrefs();

		//set checkbox prefs
		dom.pg.checked = prefs.getBoolPref(dom.pg.id);

		//set menulist prefs
		dom.cb.selectedIndex = prefs.getIntPref('globalBehavior');
	},

	getAppInfo: function() {
		return Components.classes['@mozilla.org/xre/app-info;1'].
		createInstance(Components.interfaces.nsIXULAppInfo);
	},

	onDialogAccept: function() {
		var dom = this.getDOM();
		var prefs = this.getPrefs();
		var brows = this.getAppInfo();
		var win = this.getWin((brows.name!='Thunderbird') ? 'navigator:browser' : 'mail:3pane');

		//set checkbox prefs
		prefs.setBoolPref(dom.pg.id,dom.pg.checked);

		//set menulist prefs
		prefs.setIntPref('globalBehavior',dom.cb.value);

		//change global behavior
		win.cookiesafe.allowAll(true);
	},

	getDOM: function() {
		var cb = document.getElementById('cookieBehavior');
		var pg = document.getElementById('promptGlobal');

		return {cb:cb,pg:pg};
	},

	getWin: function(name) {
		return Components.classes["@mozilla.org/appshell/window-mediator;1"].
		getService(Components.interfaces.nsIWindowMediator).
		getMostRecentWindow(name);
	},

	getPrefs: function() {
		return Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("cookiesafe.");
	}
};
