/***************************************************************************
Name: CS Lite
Description: Control cookie permissions.
Author: Ron Beckman
Homepage: http://forum.softwareblaze.com

Copyright (C) 2007  Ron Beckman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

Free Software Foundation, Inc.
51 Franklin Street
Fifth Floor
Boston, MA  02110-1301
USA
***************************************************************************/



var cookiesafeUpdate = {

	updateUrl: 'http://cookies.softwareblaze.com/blocklist_public/blocklist.php',

	getStr: function(name) {
		return document.getElementById("cookiesafe-bundle").getString(name);
	},

	getObserver: function() {
		return Components.classes["@mozilla.org/observer-service;1"].
		getService(Components.interfaces.nsIObserverService);
	},

	getPrefs: function() {
		return Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("cookiesafe.");
	},

	getAppInfo: function() {
		return Components.classes['@mozilla.org/xre/app-info;1'].
		createInstance(Components.interfaces.nsIXULAppInfo);
	},

	getPermManager: function() {
		//check if browser is TB2
		var brows = this.getAppInfo();
		var num = parseInt(brows.version);
		if (brows.name=='Thunderbird' && num==2) {
			return Components.classes["@mozilla.org/CSPermManager;1"].
			getService(Components.interfaces.nsICSPermManager);
		} else {
			return Components.classes["@mozilla.org/permissionmanager;1"].
			getService(Components.interfaces.nsIPermissionManager);
		}
	},

	getURI: function(url) {
		return Components.classes["@mozilla.org/network/io-service;1"].
		getService(Components.interfaces.nsIIOService).
		newURI(url,null,null);
	},

	uncheck: function(item) {
		var untr = document.getElementById('untrusted');
		var bU = document.getElementById('blockUntrusted');
		if (!bU.checked && item.parentNode==untr) return false;

		var checked = item.firstChild.getAttribute('checked').toString();
		item.firstChild.setAttribute('checked',(checked=='true') ? false : true);
		return false;
	},

	onDialogLoad: function() {
		var listitem,listcell;
		var prefs = this.getPrefs();
		var bU = prefs.getBoolPref('blockUntrusted');

		var blk = document.getElementById('block');
		for (var i=0; i<window.arguments[0].length; ++i) {
			listitem = document.createElement('listitem');
			listitem.setAttribute('ondblclick','cookiesafeUpdate.uncheck(this);');
			listcell = document.createElement('listcell');
			listcell.setAttribute('type','checkbox');
			listcell.setAttribute('checked','true');
			listcell.setAttribute('label',window.arguments[0][i]);
			listitem.appendChild(listcell);
			blk.appendChild(listitem);
		}

		var untr = document.getElementById('untrusted');
		for (var i=0; i<window.arguments[1].length; ++i) {
			listitem = document.createElement('listitem');
			listitem.setAttribute('ondblclick','cookiesafeUpdate.uncheck(this);');
			listcell = document.createElement('listcell');
			listcell.setAttribute('type','checkbox');
			listcell.setAttribute('checked',(bU) ? true : false);
			listcell.setAttribute('label',window.arguments[1][i]);
			listitem.appendChild(listcell);
			untr.appendChild(listitem);
		}

		var bt = document.getElementById('blockTotal');
		bt.setAttribute('value',this.getStr('cookiesafe.lTotal')+' '+window.arguments[0].length);
		var ut = document.getElementById('untrustedTotal');
		ut.setAttribute('value',this.getStr('cookiesafe.lTotal')+' '+window.arguments[1].length);

		document.getElementById('blockUntrusted').checked = bU;
	},

	onDialogAccept: function() {
		var hosts = [];
		var prefs = this.getPrefs();
		var untr = document.getElementById('untrusted');
		var blkUn = document.getElementById('blockUntrusted');
		prefs.setBoolPref('blockUntrusted',blkUn.checked);
		var listcells = document.getElementsByTagName('listcell');

		for (var i=0; i<listcells.length; ++i) {
			if (listcells[i].getAttribute('checked').toString()=='true' &&
			   (listcells[i].parentNode.parentNode!=untr || blkUn.checked)) {
				hosts.push(listcells[i].getAttribute('label'));
			}
		}

		this.blockHosts(hosts);
	},

	updateBlocklist: function() {
		var httpRequest = new XMLHttpRequest();
		httpRequest.overrideMimeType('text/xml');
		httpRequest.onreadystatechange = function() { cookiesafeUpdate.processBlocklist(httpRequest); };
		httpRequest.open('GET', this.updateUrl, true);
		httpRequest.send(null);

		//save time of update
		var dt = new Date();
		var prefs = this.getPrefs();
		prefs.setIntPref('lastUpdate',parseInt(dt.getTime()/1000));
	},

	processBlocklist: function(req) {
		if (req.readyState == 4) {
			/*for some reason if the user is not connected to the network the status
			property will throw an error when it's accessed. Although when you query
			it using ('status' in req) it returns true? At this point the only thing
			to do is enclose the req.status command in try/catch brackets.*/

			try { var status = req.status; } catch(e) { return false; }

			if (status == 200 || status == 0) {
				var action,untrusted = [],block = [];
				var doc = req.responseXML;
				var hosts = doc.getElementsByTagName('host');

				for (var i=0; i<hosts.length; ++i) {
					action = cookiesafe.testPermission(hosts[i].textContent);
					if (!action) {
						block.push(hosts[i].textContent);
					} else if (action==1 || action==8) {
						untrusted.push(hosts[i].textContent);
					}
				}

				var prefs = this.getPrefs();
				var upBhvr = prefs.getIntPref('updateBehavior');
				var blkUn = prefs.getBoolPref('blockUntrusted');

				if (!block.length && !untrusted.length) {
					if (!upBhvr) cookiesafe.viewAlert(this.getStr('cookiesafe.NoUpdate'));
				} else {
					block.sort();
					untrusted.sort();
					if (!upBhvr) {
						this.viewUpdate(block,untrusted);
					} else {
						this.blockHosts((blkUn) ? block.concat(untrusted) : block);
					}
				}
			}
		}
		return false;
	},

	blockHosts: function(hosts) {
		var mngr = this.getPermManager();
		for (var i=0; i<hosts.length; ++i) {
			mngr.add(this.getURI('http://'+hosts[i]),'cookie',2);
		}

		//notify csperm-changed observer in TB2 only
		var brows = this.getAppInfo();
		var num = parseInt(brows.version);
		if (brows.name=='Thunderbird' && num==2) {
			var os = this.getObserver();
			os.notifyObservers(null,'csperm-changed','multiple');
		}
	},

	viewUpdate: function(blk,untr) {
		window.openDialog("chrome://cookiesafe/content/cookiesafeUpdate.xul","_blank", "chrome,centerscreen,resizable=yes", blk,untr);
	}
};